module Scanner where

import Char

data Token = EOS
           | Number Integer
           | Name String
           | Other Char
           deriving (Eq,Show)

readToken :: String -> (Token,String)
readToken [] = (EOS,[])
readToken (c:cs) | isDigit c    = let (t,r) = span isDigit (c:cs)
                                  in (Number (read t), r)  
                 | isAlphaNum c = let (t,r) = span isAlphaNum (c:cs)
                                  in (Name t, r)
                 | isSpace c    = readToken (dropWhile isSpace cs)
                 | otherwise    = (Other c, cs)

scanner :: String -> [Token]
scanner s = let (tok,rest) = readToken s
            in if tok == EOS then []
                             else (tok : scanner rest)  
